#!/usr/bin/php -q
<?php   

	function WriteLog ($line)
	{
	  $log = fopen("/var/log/asterisk/agi.log", "a+");
	  $date_time = date ("d/m/Y H:i:s", time ());
	  fputs($log, "${date_time}: ${line}\n");
	  fflush($log);
	  fclose ($log);
	}
    declare(ticks = 1);
    if (function_exists('pcntl_signal')) {
		   pcntl_signal(SIGHUP,  SIG_IGN);
    }

     	error_reporting(E_ALL ^ (E_NOTICE | E_WARNING));
		
	include (dirname(__FILE__)."/libs_a2billing/db_php_lib/Class.Table.php");
	include (dirname(__FILE__)."/libs_a2billing/Class.A2Billing.php");
	include (dirname(__FILE__)."/libs_a2billing/Class.RateEngine.php");	    
	include (dirname(__FILE__)."/libs_a2billing/phpagi_2_14/phpagi.php");
	include (dirname(__FILE__)."/libs_a2billing/phpagi_2_14/phpagi-asmanager.php");


	$charge_callback=0;
	$G_startime = time();
	$agi_date = "Release : 13 August 2006";
	$agi_version = "1.2.3 (BrainCoral)";
	
	/********** 	 CREATE THE AGI INSTANCE + ANSWER THE CALL		**********/
	$agi = new AGI();
	
	
	if ($argc > 1 && is_numeric($argv[1]) && $argv[1] >= 0)
		$idconfig = $argv[1];
	else
		$idconfig = 1;
	$agi->verbose('line:'.__LINE__.' - '."IDCONFIG : $idconfig \n");
	
	
	if ($argc > 2 && strlen($argv[2]) > 0 && $argv[2] == 'did')			$mode = 'did';
	elseif ($argc > 2 && strlen($argv[2]) > 0 && $argv[2] == 'callback')		$mode = 'callback';
	elseif ($argc > 2 && strlen($argv[2]) > 0 && $argv[2] == 'cid-callback')	$mode = 'cid-callback';	
	elseif ($argc > 2 && strlen($argv[2]) > 0 && $argv[2] == 'all-callback')	$mode = 'all-callback';
	elseif ($argc > 2 && strlen($argv[2]) > 0 && $argv[2] == 'predictivedialer')	$mode = 'predictivedialer';
	else $mode = 'standard';
	$agi->verbose('line:'.__LINE__.' - '."MODE : $mode \n");
	
	// get the area code for the cid-callback & all-callback
	if ($argc > 3 && strlen($argv[3]) > 0) $caller_areacode = $argv[3];
	
	$A2B = new A2Billing();
	$A2B -> load_conf($agi, NULL, 0, $idconfig);
	
	$A2B -> CC_TESTING = isset($A2B->agiconfig['debugshell']) && $A2B->agiconfig['debugshell'];	
	
	// TEST DID
	// if ($A2B -> CC_TESTING) $mode = 'did';
	
	//-- Print header
	if ($A2B->agiconfig['debug']>=1) $agi->verbose ('AGI Request:');
	if ($A2B->agiconfig['debug']>=1) $agi->verbose (print_r($agi->request, true));
	
	
	/* GET THE AGI PARAMETER */
	$A2B -> get_agi_request_parameter ($agi);
	
	//$A2B -> accountcode = '2222222222';
	
	if (!$A2B -> DbConnect()){						
		$agi-> stream_file('prepaid-final', '#');
		exit;					
	}
	
	$instance_table = new Table();
	$A2B -> set_instance_table ($instance_table);
		
	
// Get the extension number - last 3 digits of the extension
$origExten = $argv[1];
$ok = (strlen ($origExten) > 2);
if ($ok)
{
    // Check if the extension has voicemail
    $exten = substr ($origExten, -3);
    $query = "SELECT id_cc_card FROM cc_callerid WHERE (cid like '%" . $exten . "');";
    $result = $A2B -> instance_table -> SQLExec ($A2B->DBHandle, $query);
    $ok = (is_array($result));
    
    // Check if the extension is to be recorded
    WriteLog ("exten is ${exten}");
    if (($exten == "200") || ($exten == "201") || ($exten == "202") ||
        ($exten == "203") || ($exten == "204") || ($exten == "289"))
        {
        $agi->set_variable ("RecordExtension", "1");
        WriteLog ("Set variable to 1");
        }
}     

if ($ok)
{
    $cardID = $result[0][0];
    $query = "SELECT voicemail FROM cc_card WHERE (id=" . $cardID . ");";
    $result1 = $A2B -> instance_table -> SQLExec ($A2B->DBHandle, $query);
    $ok = (is_array($result1));
    if ($ok)
        $ok = ($result1[0][0] != "0");
}
if ($ok)
{
    $agi->set_variable ("HasVoicemail", "1");
    $agi->set_variable ("CardID", $cardID);
}
else
  $agi->set_variable ("HasVoicemail", "0");
  

?>
