#!/usr/bin/php -q
<?php   

    declare(ticks = 1);
    if (function_exists('pcntl_signal')) {
		   pcntl_signal(SIGHUP,  SIG_IGN);
    }

     	error_reporting(E_ALL ^ (E_NOTICE | E_WARNING));
		
	include (dirname(__FILE__)."/libs_a2billing/db_php_lib/Class.Table.php");
	include (dirname(__FILE__)."/libs_a2billing/Class.A2Billing.php");
	include (dirname(__FILE__)."/libs_a2billing/Class.RateEngine.php");	    
	include (dirname(__FILE__)."/libs_a2billing/phpagi_2_14/phpagi.php");
	include (dirname(__FILE__)."/libs_a2billing/phpagi_2_14/phpagi-asmanager.php");


	$charge_callback=0;
	$G_startime = time();
	$agi_date = "Release : 13 August 2006";
	$agi_version = "1.2.3 (BrainCoral)";
	
	/********** 	 CREATE THE AGI INSTANCE + ANSWER THE CALL		**********/
	$agi = new AGI();
	
	
	if ($argc > 1 && is_numeric($argv[1]) && $argv[1] >= 0)
		$idconfig = $argv[1];
	else
		$idconfig = 1;
	$agi->verbose('line:'.__LINE__.' - '."IDCONFIG : $idconfig \n");
	
	
	if ($argc > 2 && strlen($argv[2]) > 0 && $argv[2] == 'did')			$mode = 'did';
	elseif ($argc > 2 && strlen($argv[2]) > 0 && $argv[2] == 'callback')		$mode = 'callback';
	elseif ($argc > 2 && strlen($argv[2]) > 0 && $argv[2] == 'cid-callback')	$mode = 'cid-callback';	
	elseif ($argc > 2 && strlen($argv[2]) > 0 && $argv[2] == 'all-callback')	$mode = 'all-callback';
	elseif ($argc > 2 && strlen($argv[2]) > 0 && $argv[2] == 'predictivedialer')	$mode = 'predictivedialer';
	else $mode = 'standard';
	$agi->verbose('line:'.__LINE__.' - '."MODE : $mode \n");
	
	// get the area code for the cid-callback & all-callback
	if ($argc > 3 && strlen($argv[3]) > 0) $caller_areacode = $argv[3];
	
	
	$A2B = new A2Billing();
	$A2B -> load_conf($agi, NULL, 0, $idconfig);
	
	$A2B -> CC_TESTING = isset($A2B->agiconfig['debugshell']) && $A2B->agiconfig['debugshell'];	
	
	// TEST DID
	// if ($A2B -> CC_TESTING) $mode = 'did';
	
	//-- Print header
	if ($A2B->agiconfig['debug']>=1) $agi->verbose ('AGI Request:');
	if ($A2B->agiconfig['debug']>=1) $agi->verbose (print_r($agi->request, true));
	
	
	/* GET THE AGI PARAMETER */
	$A2B -> get_agi_request_parameter ($agi);
	
	//$A2B -> accountcode = '2222222222';
	
	if (!$A2B -> DbConnect()){						
		$agi-> stream_file('prepaid-final', '#');
		exit;					
	}
	
	$instance_table = new Table();
	$A2B -> set_instance_table ($instance_table);
		
	function WriteLog ($line)
	{
	  $log = fopen("/var/log/asterisk/agi.log", "a+");
	  $date_time = date ("d/m/Y H:i:s", time ());
	  fputs($log, "${date_time}: ${line}\n");
	  fflush($log);
	  fclose ($log);
	}
	
// First check if the card ID is passed through the dialplan
$errorCount = 0;
$cardID = $agi->get_variable ("CardID", $cardID);
if (is_array ($cardID))
{
    $cardID = $cardID['data'];
    $query = "SELECT id FROM cc_card WHERE (id=" . $cardID . ")";
    $result = $A2B -> instance_table -> SQLExec ($A2B->DBHandle, $query);
    $ok = (is_array($result));
}
else
    $ok = false;

// Ask the caller to enter the customer ID
while ((!$ok) && ($errorCount < 3))
{
    $errorCount++;
    $resDTMF = $agi->get_data ("a2billing/voicemail/enter_customer_id", 5000, 4);
    $cardID = $resDTMF ["result"];
    $query = "SELECT id FROM cc_card WHERE (id=" . $cardID . ")";
    $result = $A2B -> instance_table -> SQLExec ($A2B->DBHandle, $query);
    $ok = (is_array($result));
    if (!$ok)
    {
        $agi->stream_file ("a2billing/voicemail/wrong_customer_id");
        if ($errorCount < 3)
            $agi->stream_file ("a2billing/voicemail/try_again");
        else
        {
            $agi->stream_file ("a2billing/voicemail/too_many_errors");
            exit ();
        }
    }
}
                                                                                                                    
// Record the mesasge file
$filename = "a2billing/voicemail/messages/" . time () . "_" . $cardID;
$agi->stream_file ("a2billing/voicemail/start_recording");
$result = $agi->record_file ($filename, "gsm", "#", 300000, NULL, 5);

// Insert a new record into the database
$query = "INSERT INTO cc_voicemail (CardNumber,MessageFile,MessageDate,CallerID) VALUES (";
$query .= $cardID . ",'" . $filename ."','" . date ("Y-m-d H:i:s") . "','" . $agi->request['agi_callerid'] . "')";
$result = $A2B -> instance_table -> SQLExec ($A2B->DBHandle, $query, 0);
?>
